import * as J from "vue";
import { getCurrentScope as oe, onScopeDispose as ne, hasInjectionContext as de, inject as he, getCurrentInstance as re, ref as se, watch as me, reactive as _e, markRaw as x, effectScope as Ee, isRef as k, isReactive as H, toRef as $, toRaw as ge, nextTick as M, computed as ce, toRefs as q, defineComponent as ve, resolveComponent as Q, openBlock as be, createElementBlock as ye, Fragment as Ne, createTextVNode as X, toDisplayString as Y, unref as Oe, createVNode as Z, withCtx as Ve, createElementVNode as Pe, defineCustomElement as Se } from "vue";
function xe(e) {
  return oe() ? (ne(e), !0) : !1;
}
function De() {
  const e = /* @__PURE__ */ new Set(), c = (s) => {
    e.delete(s);
  };
  return {
    on: (s) => {
      e.add(s);
      const a = () => c(s);
      return xe(a), {
        off: a
      };
    },
    off: c,
    trigger: (...s) => Promise.all(Array.from(e).map((a) => a(...s)))
  };
}
typeof WorkerGlobalScope < "u" && globalThis instanceof WorkerGlobalScope;
var we = !1;
function C(e, c, r) {
  return Array.isArray(e) ? (e.length = Math.max(e.length, c), e.splice(c, 1, r), r) : (e[c] = r, r);
}
function F(e, c) {
  if (Array.isArray(e)) {
    e.splice(c, 1);
    return;
  }
  delete e[c];
}
/*!
 * pinia v2.1.7
 * (c) 2023 Eduardo San Martin Morote
 * @license MIT
 */
let D;
const A = (e) => D = e, ke = process.env.NODE_ENV !== "production" ? Symbol("pinia") : (
  /* istanbul ignore next */
  Symbol()
);
function N(e) {
  return e && typeof e == "object" && Object.prototype.toString.call(e) === "[object Object]" && typeof e.toJSON != "function";
}
var w;
(function(e) {
  e.direct = "direct", e.patchObject = "patch object", e.patchFunction = "patch function";
})(w || (w = {}));
const W = typeof window < "u", R = (process.env.NODE_ENV !== "production" || !1) && process.env.NODE_ENV !== "test" && W;
function ie(e, c) {
  for (const r in c) {
    const t = c[r];
    if (!(r in e))
      continue;
    const s = e[r];
    N(s) && N(t) && !k(t) && !H(t) ? e[r] = ie(s, t) : e[r] = t;
  }
  return e;
}
const ae = () => {
};
function K(e, c, r, t = ae) {
  e.push(c);
  const s = () => {
    const a = e.indexOf(c);
    a > -1 && (e.splice(a, 1), t());
  };
  return !r && oe() && ne(s), s;
}
function V(e, ...c) {
  e.slice().forEach((r) => {
    r(...c);
  });
}
const je = (e) => e();
function L(e, c) {
  e instanceof Map && c instanceof Map && c.forEach((r, t) => e.set(t, r)), e instanceof Set && c instanceof Set && c.forEach(e.add, e);
  for (const r in c) {
    if (!c.hasOwnProperty(r))
      continue;
    const t = c[r], s = e[r];
    N(s) && N(t) && e.hasOwnProperty(r) && !k(t) && !H(t) ? e[r] = L(s, t) : e[r] = t;
  }
  return e;
}
const Ce = process.env.NODE_ENV !== "production" ? Symbol("pinia:skipHydration") : (
  /* istanbul ignore next */
  Symbol()
);
function Ae(e) {
  return !N(e) || !e.hasOwnProperty(Ce);
}
const { assign: v } = Object;
function ee(e) {
  return !!(k(e) && e.effect);
}
function te(e, c, r, t) {
  const { state: s, actions: a, getters: l } = c, f = r.state.value[e];
  let b;
  function d() {
    !f && (process.env.NODE_ENV === "production" || !t) && (r.state.value[e] = s ? s() : {});
    const _ = process.env.NODE_ENV !== "production" && t ? (
      // use ref() to unwrap refs inside state TODO: check if this is still necessary
      q(se(s ? s() : {}).value)
    ) : q(r.state.value[e]);
    return v(_, a, Object.keys(l || {}).reduce((p, h) => (process.env.NODE_ENV !== "production" && h in _ && console.warn(`[🍍]: A getter cannot have the same name as another state property. Rename one of them. Found with "${h}" in store "${e}".`), p[h] = x(ce(() => {
      A(r);
      const E = r._s.get(e);
      return l[h].call(E, E);
    })), p), {}));
  }
  return b = U(e, d, c, r, t, !0), b;
}
function U(e, c, r = {}, t, s, a) {
  let l;
  const f = v({ actions: {} }, r);
  if (process.env.NODE_ENV !== "production" && !t._e.active)
    throw new Error("Pinia destroyed");
  const b = {
    deep: !0
    // flush: 'post',
  };
  process.env.NODE_ENV !== "production" && !we && (b.onTrigger = (n) => {
    d ? E = n : d == !1 && !i._hotUpdating && (Array.isArray(E) ? E.push(n) : console.error("🍍 debuggerEvents should be an array. This is most likely an internal Pinia bug."));
  });
  let d, _, p = [], h = [], E;
  const O = t.state.value[e];
  !a && !O && (process.env.NODE_ENV === "production" || !s) && (t.state.value[e] = {});
  const I = se({});
  let z;
  function B(n) {
    let o;
    d = _ = !1, process.env.NODE_ENV !== "production" && (E = []), typeof n == "function" ? (n(t.state.value[e]), o = {
      type: w.patchFunction,
      storeId: e,
      events: E
    }) : (L(t.state.value[e], n), o = {
      type: w.patchObject,
      payload: n,
      storeId: e,
      events: E
    });
    const u = z = Symbol();
    M().then(() => {
      z === u && (d = !0);
    }), _ = !0, V(p, o, t.state.value[e]);
  }
  const ue = a ? function() {
    const { state: o } = r, u = o ? o() : {};
    this.$patch((m) => {
      v(m, u);
    });
  } : (
    /* istanbul ignore next */
    process.env.NODE_ENV !== "production" ? () => {
      throw new Error(`🍍: Store "${e}" is built using the setup syntax and does not implement $reset().`);
    } : ae
  );
  function fe() {
    l.stop(), p = [], h = [], t._s.delete(e);
  }
  function T(n, o) {
    return function() {
      A(t);
      const u = Array.from(arguments), m = [], P = [];
      function le(g) {
        m.push(g);
      }
      function pe(g) {
        P.push(g);
      }
      V(h, {
        args: u,
        name: n,
        store: i,
        after: le,
        onError: pe
      });
      let S;
      try {
        S = o.apply(this && this.$id === e ? this : i, u);
      } catch (g) {
        throw V(P, g), g;
      }
      return S instanceof Promise ? S.then((g) => (V(m, g), g)).catch((g) => (V(P, g), Promise.reject(g))) : (V(m, S), S);
    };
  }
  const j = /* @__PURE__ */ x({
    actions: {},
    getters: {},
    state: [],
    hotState: I
  }), G = {
    _p: t,
    // _s: scope,
    $id: e,
    $onAction: K.bind(null, h),
    $patch: B,
    $reset: ue,
    $subscribe(n, o = {}) {
      const u = K(p, n, o.detached, () => m()), m = l.run(() => me(() => t.state.value[e], (P) => {
        (o.flush === "sync" ? _ : d) && n({
          storeId: e,
          type: w.direct,
          events: E
        }, P);
      }, v({}, b, o)));
      return u;
    },
    $dispose: fe
  }, i = _e(process.env.NODE_ENV !== "production" || R ? v(
    {
      _hmrPayload: j,
      _customProperties: x(/* @__PURE__ */ new Set())
      // devtools custom properties
    },
    G
    // must be added later
    // setupStore
  ) : G);
  t._s.set(e, i);
  const y = (t._a && t._a.runWithContext || je)(() => t._e.run(() => (l = Ee()).run(c)));
  for (const n in y) {
    const o = y[n];
    if (k(o) && !ee(o) || H(o))
      process.env.NODE_ENV !== "production" && s ? C(I.value, n, $(y, n)) : a || (O && Ae(o) && (k(o) ? o.value = O[n] : L(o, O[n])), t.state.value[e][n] = o), process.env.NODE_ENV !== "production" && j.state.push(n);
    else if (typeof o == "function") {
      const u = process.env.NODE_ENV !== "production" && s ? o : T(n, o);
      y[n] = u, process.env.NODE_ENV !== "production" && (j.actions[n] = o), f.actions[n] = o;
    } else
      process.env.NODE_ENV !== "production" && ee(o) && (j.getters[n] = a ? (
        // @ts-expect-error
        r.getters[n]
      ) : o, W && (y._getters || // @ts-expect-error: same
      (y._getters = x([]))).push(n));
  }
  if (v(i, y), v(ge(i), y), Object.defineProperty(i, "$state", {
    get: () => process.env.NODE_ENV !== "production" && s ? I.value : t.state.value[e],
    set: (n) => {
      if (process.env.NODE_ENV !== "production" && s)
        throw new Error("cannot set hotState");
      B((o) => {
        v(o, n);
      });
    }
  }), process.env.NODE_ENV !== "production" && (i._hotUpdate = x((n) => {
    i._hotUpdating = !0, n._hmrPayload.state.forEach((o) => {
      if (o in i.$state) {
        const u = n.$state[o], m = i.$state[o];
        typeof u == "object" && N(u) && N(m) ? ie(u, m) : n.$state[o] = m;
      }
      C(i, o, $(n.$state, o));
    }), Object.keys(i.$state).forEach((o) => {
      o in n.$state || F(i, o);
    }), d = !1, _ = !1, t.state.value[e] = $(n._hmrPayload, "hotState"), _ = !0, M().then(() => {
      d = !0;
    });
    for (const o in n._hmrPayload.actions) {
      const u = n[o];
      C(i, o, T(o, u));
    }
    for (const o in n._hmrPayload.getters) {
      const u = n._hmrPayload.getters[o], m = a ? (
        // special handling of options api
        ce(() => (A(t), u.call(i, i)))
      ) : u;
      C(i, o, m);
    }
    Object.keys(i._hmrPayload.getters).forEach((o) => {
      o in n._hmrPayload.getters || F(i, o);
    }), Object.keys(i._hmrPayload.actions).forEach((o) => {
      o in n._hmrPayload.actions || F(i, o);
    }), i._hmrPayload = n._hmrPayload, i._getters = n._getters, i._hotUpdating = !1;
  })), R) {
    const n = {
      writable: !0,
      configurable: !0,
      // avoid warning on devtools trying to display this property
      enumerable: !1
    };
    ["_p", "_hmrPayload", "_getters", "_customProperties"].forEach((o) => {
      Object.defineProperty(i, o, v({ value: i[o] }, n));
    });
  }
  return t._p.forEach((n) => {
    if (R) {
      const o = l.run(() => n({
        store: i,
        app: t._a,
        pinia: t,
        options: f
      }));
      Object.keys(o || {}).forEach((u) => i._customProperties.add(u)), v(i, o);
    } else
      v(i, l.run(() => n({
        store: i,
        app: t._a,
        pinia: t,
        options: f
      })));
  }), process.env.NODE_ENV !== "production" && i.$state && typeof i.$state == "object" && typeof i.$state.constructor == "function" && !i.$state.constructor.toString().includes("[native code]") && console.warn(`[🍍]: The "state" must be a plain object. It cannot be
	state: () => new MyClass()
Found in store "${i.$id}".`), O && a && r.hydrate && r.hydrate(i.$state, O), d = !0, _ = !0, i;
}
function Ie(e, c, r) {
  let t, s;
  const a = typeof c == "function";
  if (typeof e == "string")
    t = e, s = a ? r : c;
  else if (s = e, t = e.id, process.env.NODE_ENV !== "production" && typeof t != "string")
    throw new Error('[🍍]: "defineStore()" must be passed a store id as its first argument.');
  function l(f, b) {
    const d = de();
    if (f = // in test mode, ignore the argument provided as we can always retrieve a
    // pinia instance with getActivePinia()
    (process.env.NODE_ENV === "test" && D && D._testing ? null : f) || (d ? he(ke, null) : null), f && A(f), process.env.NODE_ENV !== "production" && !D)
      throw new Error(`[🍍]: "getActivePinia()" was called but there was no active Pinia. Are you trying to use a store before calling "app.use(pinia)"?
See https://pinia.vuejs.org/core-concepts/outside-component-usage.html for help.
This will fail in production.`);
    f = D, f._s.has(t) || (a ? U(t, c, s, f) : te(t, s, f), process.env.NODE_ENV !== "production" && (l._pinia = f));
    const _ = f._s.get(t);
    if (process.env.NODE_ENV !== "production" && b) {
      const p = "__hot:" + t, h = a ? U(p, c, s, f, !0) : te(p, v({}, s), f, !0);
      b._hotUpdate(h), delete f.state.value[p], f._s.delete(p);
    }
    if (process.env.NODE_ENV !== "production" && W) {
      const p = re();
      if (p && p.proxy && // avoid adding stores that are just built for hot module replacement
      !b) {
        const h = p.proxy, E = "_pStores" in h ? h._pStores : h._pStores = {};
        E[t] = _;
      }
    }
    return _;
  }
  return l.$id = t, l;
}
const $e = Ie("user", () => ({ name: "carla" })), Fe = /* @__PURE__ */ ve({
  __name: "App.ce",
  props: {
    foo: String,
    isACustomElement: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["clicked"],
  setup(e, { emit: c }) {
    const r = e, t = c;
    r.isACustomElement;
    const s = $e();
    function a() {
      console.log("clicked from vue component"), t("clicked", { name: "carla" });
    }
    return (l, f) => {
      const b = Q("router-link"), d = Q("router-view");
      return be(), ye(Ne, null, [
        X(" Hello " + Y(Oe(s).name) + " ", 1),
        Z(b, { to: "/hello" }, {
          default: Ve(() => [
            X("Go to About")
          ]),
          _: 1
        }),
        Pe("button", { onClick: a }, Y(e.foo || "foo is null"), 1),
        Z(d)
      ], 64);
    };
  }
}), Re = ".logo{height:6em;padding:1.5em;will-change:filter;transition:filter .3s}.logo:hover{filter:drop-shadow(0 0 2em #646cffaa)}.logo.vue:hover{filter:drop-shadow(0 0 2em #42b883aa)}:root{font-family:Inter,system-ui,Avenir,Helvetica,Arial,sans-serif;line-height:1.5;font-weight:400;color-scheme:light dark;color:#ffffffde;background-color:#242424;font-synthesis:none;text-rendering:optimizeLegibility;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}a{font-weight:500;color:#646cff;text-decoration:inherit}a:hover{color:#535bf2}body{margin:0;display:flex;place-items:center;min-width:320px;min-height:100vh}h1{font-size:3.2em;line-height:1.1}button{border-radius:8px;border:1px solid transparent;padding:.6em 1.2em;font-size:1em;font-weight:500;font-family:inherit;background-color:#1a1a1a;cursor:pointer;transition:border-color .25s}button:hover{border-color:#646cff}button:focus,button:focus-visible{outline:4px auto -webkit-focus-ring-color}.card{padding:2em}#app{max-width:1280px;margin:0 auto;padding:2rem;text-align:center}@media (prefers-color-scheme: light){:root{color:#213547;background-color:#fff}a:hover{color:#747bff}button{background-color:#f9f9f9}}", Le = (e, c) => {
  const r = e.__vccOpts || e;
  for (const [t, s] of c)
    r[t] = s;
  return r;
}, Ue = /* @__PURE__ */ Le(Fe, [["styles", [Re]]]), ze = (e) => {
  const c = re(), r = De();
  if (J.onBeforeUnmount(() => r.trigger(void 0)), !c)
    throw new Error("useCeVueApp(): could not find vue instance!");
  const t = {
    version: "FAKE_APP_FOR_CE",
    get config() {
      return c.appContext.config;
    },
    provide(s, a) {
      return J.provide(s, a), t;
    },
    onUnmount(s) {
      r.on(s);
    },
    use(s, ...a) {
      const l = t;
      return s.install && s.install(l, ...a), typeof s == "function" && s(l, ...a), t;
    }
  };
  e(t);
};
function Be() {
  const e = Se(Ue);
  customElements.define("vuejs-example", e);
}
export {
  Be as declareVuejsExample,
  ze as registerPluginsForCustomElement
};
